package com.ruoyi.web.controller;

import cn.hutool.core.date.DateUtil;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.webservice.SoapClient;
import cn.hutool.json.JSONUtil;
import com.ruoyi.server.IReciveDataService;
import com.ruoyi.server.ReciveDataService;
import com.ruoyi.web.service.ReqBO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.UUID;

@RestController
@RequestMapping("test")
@Slf4j
public class TestController {

    @Value("${interface.appid}")
    private String appid;



    @RequestMapping("do")
    public String test() {
        ReciveDataService service = new ReciveDataService();
        IReciveDataService port = service.getWSHttpBindingIReciveDataService();
        String date = DateUtil.now();
        String queryId = UUID.randomUUID().toString();
        // 构建您的请求数据，例如 JSON 格式
        String inputData = "{\"APP_ID\":\"" + appid + "\",\"QUERY_ID\":\"" + queryId + "\",\"DATAS\":[{\"PERSON_CODE\":\"7081001\",\"PERSON_NAME\":\"测试\",\"SIGN_DATE\":\"" + date + "\"}]}";
        log.info("=====inputData: " + inputData);
        // 调用服务
        String result = port.recive(inputData);

        log.info("=====Result: " + result);
        return result;
    }




    @RequestMapping("do2")
    public String do2() {
        String cardNo = "12345678";
        String name = "张三";
        String eventTime = DateUtil.now();
        //interfaceService.req(cardNo, name, eventTime);
        return "ok";
    }


    @RequestMapping("req")
    public String req(String type) {
        String date = DateUtil.now();
        String queryId = UUID.randomUUID().toString();
        log.info("type:{}", type);
        String inputData = "{\"APP_ID\":\"" + appid + "\",\"QUERY_ID\":\"" + queryId + "\",\"DATAS\":[{\"PERSON_CODE\":\"7081001\",\"PERSON_NAME\":\"测试\",\"SIGN_DATE\":\"" + date + "\"}]}";
        SoapClient client = SoapClient.create("http://kms-neikong-01.kmc.intra.customs.gov.cn:9918/ReciveDataService.svc")
                .header("SOAPAction", "http:/tempuri.org/IReciveDataService/Recive")
                .header("Content-Type", type)
                // 设置要请求的方法，此接口方法前缀为web，传入对应的命名空间
                .setMethod("tem:Recive", "http://tempuri.org/")
                // 设置参数，此处自动添加方法的前缀：web
                .setParam("jsonData", inputData);
        log.info("报文:\n{}", client.getMsgStr(true));
        String body;
        try (HttpResponse response = client.sendForResponse()) {
            body = response.body();
        }
        log.info("结果:\n{}", body);
        return body;
    }

    @RequestMapping("r")
    public void req(String cardNo,String name,String eventTime) {
        ReqBO reqBO = new ReqBO();
        reqBO.setCarNo(cardNo).setReqTime(eventTime).setName(name);
        String resp = HttpUtil.post("http://127.0.0.1:9090/api/req", JSONUtil.toJsonStr(reqBO));
        log.info("resp:{}",resp);
    }

}
