package com.ruoyi.web.hksdk;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.extra.spring.SpringUtil;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONUtil;
import com.ruoyi.web.component.CaputreSetting;
import com.ruoyi.web.component.InterfaceUrl;
import com.ruoyi.web.service.ReqBO;
import com.sun.jna.Pointer;
import lombok.extern.slf4j.Slf4j;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.nio.ByteBuffer;
import java.time.*;
import java.util.Map;

@Component
@Slf4j
@Order(value = 999)
public class MessageCallBack implements HCNetSDK.FMSGCallBack_V31 {

    @Resource
    private CaputreSetting caputreSetting;
    @Resource
    private InterfaceUrl interfaceUrl;

    @Override
    public boolean invoke(int lCommand, HCNetSDK.NET_DVR_ALARMER pAlarmer, Pointer pAlarmInfo, int dwBufLen, Pointer pUser) {
        //alarmParseService.alarmDataHandle(lCommand,pAlarmer,pAlarmInfo,dwBufLen,pUser);
        processAlarmEvent(pAlarmer, pAlarmInfo);
        return false;
    }

    private void processAlarmEvent(HCNetSDK.NET_DVR_ALARMER pAlarmer, Pointer pAlarmInfo) {
        String[] sIP = new String[2];
        sIP = new String(pAlarmer.sDeviceIP).split("\0", 2);
        //报警设备ip
        String ip = sIP[0];
        String employeeId = null;
        Byte cardType = null;

        HCNetSDK.NET_DVR_ACS_ALARM_INFO strACSInfo = new HCNetSDK.NET_DVR_ACS_ALARM_INFO();
        strACSInfo.write();
        Pointer pACSInfo = strACSInfo.getPointer();
        pACSInfo.write(0, pAlarmInfo.getByteArray(0, strACSInfo.size()), 0, strACSInfo.size());
        strACSInfo.read();
        //主类型 5 事件上报
        if (strACSInfo.dwMajor != 5) {
            return;
        }
        /*
        byte timeType = strACSInfo.byTimeType;
        HCNetSDK.NET_DVR_TIME struTime = strACSInfo.struTime;
        LocalDateTime uplaodTime = LocalDateTime.of(struTime.dwYear, struTime.dwMonth, struTime.dwDay, struTime.dwHour, struTime.dwMinute, struTime.dwSecond);
        DateTimeFormatter fmt = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        if (timeType == 0) {
            eventTime = uplaodTime.format(fmt);
        } else if (timeType == 1) {
            ZonedDateTime zonedDateTime = uplaodTime.atZone(ZoneId.from(ZoneOffset.UTC)).withZoneSameInstant(ZoneId.systemDefault());
            eventTime = zonedDateTime.format(fmt);
        } else {
            log.info("上报时间不正确");
        }*/

       // cardNo = new String(strACSInfo.struAcsEventInfo.byCardNo).trim();
        cardType = strACSInfo.struAcsEventInfo.byCardType;
       // log.info("卡号cardNo="+cardNo);
       log.info("卡类型cardType="+cardType);

        //以人为中心设备
        if (strACSInfo.byAcsEventInfoExtend == 1) {
            HCNetSDK.NET_DVR_ACS_EVENT_INFO_EXTEND test = new HCNetSDK.NET_DVR_ACS_EVENT_INFO_EXTEND();
            test.write();
            Pointer pAcsEventInfoExtend = test.getPointer();
            pAcsEventInfoExtend.write(0, strACSInfo.pAcsEventInfoExtend.getByteArray(0, test.size()), 0, test.size());
            test.read();
            employeeId = new String(test.byEmployeeNo).trim();
        }
        log.info("员工employeeId="+employeeId);

        HkAdapter hkAdapter = SpringUtil.getBean(HkAdapter.class);
        Map<String, String> map = hkAdapter.eventUserInfo(employeeId);
        String name = map.get("name");
        log.info("员工姓名name="+name);
        String roomNumber = map.get("roomNumber");
        log.info("房间号="+roomNumber);

        if (strACSInfo.dwPicDataLen > 0) {
            long offset = 0;
            ByteBuffer buffers = strACSInfo.pPicData.getByteBuffer(offset, strACSInfo.dwPicDataLen);
            byte[] bytes = new byte[strACSInfo.dwPicDataLen];
            buffers.rewind();
            buffers.get(bytes);
            log.info("有图片");
        }
        String cardNo = employeeId;
        String eventTime = DateUtil.now();
        log.info("刷卡时间eventTime="+eventTime);
        //密码认证通过
        if (strACSInfo.dwMinor == 181) {
            log.info("密码认证通过============dwMinor============"+strACSInfo.dwMinor);
            if(StrUtil.equals(roomNumber,"1")) {//房间1即为编内人员，需发往总关
                req(cardNo, name, eventTime);
            }
        }
        //密码认证失败
        else if (strACSInfo.dwMinor == 151) {
            log.info("密码认证失败============dwMinor============"+strACSInfo.dwMinor);
        }
        //刷脸成功
        else if (strACSInfo.dwMinor == 75) {
            log.info("刷脸成功============dwMinor============"+strACSInfo.dwMinor);
            if(StrUtil.equals(roomNumber,"1")) {//房间1即为编内人员，需发往总关
                req(cardNo, name, eventTime);
            }
        }
        //刷脸失败
        else if (strACSInfo.dwMinor == 76) {
            log.info("刷脸失败============dwMinor============"+strACSInfo.dwMinor);
        }
        //门锁打开
        else if (strACSInfo.dwMinor == 21) {
            log.info("门锁打开============dwMinor============"+strACSInfo.dwMinor);
        }
        //门锁关闭
        else if (strACSInfo.dwMinor == 22) {
            log.info("门锁关闭============dwMinor============"+strACSInfo.dwMinor);
        }
        // 刷卡成功
        else if (strACSInfo.dwMinor == 1) {
            log.info("刷脸成功============dwMinor============"+strACSInfo.dwMinor);
        }
        else {
            log.info("(不是刷脸也不是密码打卡，打卡无效)dwMinor============"+strACSInfo.dwMinor);
            if(StrUtil.equals(roomNumber,"1")) {//房间1即为编内人员，需发往总关
                req(cardNo, name, eventTime);
            }
        }
    }

    public void req(String cardNo, String name, String eventTime) {
        if (StrUtil.isEmpty(name)||StrUtil.isEmpty(cardNo)){
            log.error("数据获取异常:{},{}",cardNo,name);
            return;
        }

        String start = caputreSetting.getStarttime();
        String[] startArr = start.split(":");
        int startHour = Integer.parseInt(startArr[0]);
        int startMinute = Integer.parseInt(startArr[1]);

        String end = caputreSetting.getEndtime();
        String[] endArr = end.split(":");
        int endHour = Integer.parseInt(endArr[0]);
        int endMinute = Integer.parseInt(endArr[1]);

        LocalTime nowTime = LocalTime.now();
        LocalTime startTime = LocalTime.of(startHour, startMinute);
        LocalTime endTime = LocalTime.of(endHour, endMinute);

        if(nowTime.isBefore(startTime) || nowTime.isAfter(endTime)) {
            ReqBO reqBO = new ReqBO();
            reqBO.setCarNo(cardNo).setReqTime(eventTime).setName(name);
            log.info("reqBO:{}",JSONUtil.toJsonStr(reqBO));
            String apiUrl = interfaceUrl.getApiUrl();
            String resp = HttpUtil.post(apiUrl, JSONUtil.toJsonStr(reqBO));
            log.info("resp:{}",resp);
        }
    }

}
