package com.ruoyi.web.startup;

import com.ruoyi.web.cache.CacheManager;
import com.ruoyi.web.component.CaputreSetting;
import com.ruoyi.web.hksdk.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
@Slf4j
public class StartupRunner implements CommandLineRunner {

    @Resource
    private CaputreSetting caputreSetting;
    @Resource
    private HkUtils hkUtils;
    @Resource
    private HCNetSDK hcNetSDK;

    @Override
    public void run(String... args) throws Exception {
        short port = (short) caputreSetting.getPort();
        String ip = caputreSetting.getHost();
        int userId = hkUtils.Login_V40(ip, port, caputreSetting.getUsername(), caputreSetting.getPwd(), hcNetSDK);
        if (userId != -1) {
            log.info("登录海康威视人脸识别门禁设备:{},{}", ip, userId);
            hkUtils.SetAlarm(hcNetSDK, userId);
            HKCacheManager.add(ModuleEnum.CAPTURE_MODULE, userId);
            CacheManager.put(userId);
        } else {
            log.info("登录海康威视人脸识别门禁设备失败:{},{}", hcNetSDK.NET_DVR_GetLastError(), userId);
        }
    }


}
